//+------------------------------------------------------------------+
//|                                                     3xMAs#2 .mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Aqua
#property indicator_color2 Yellow
#property indicator_color3 Magenta

//---- input parameters
extern int EMAPeriod=3;           
extern int EMAShift=0;             
extern int SEMAPeriod=7;          
extern int SEMAShift=0;            
extern int SSEMAPeriod=25;         
extern int SSEMAShift=0;           
//---- indicator buffers
double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
//---- line shifts when drawing
   SetIndexShift(0,EMAShift);
   SetIndexShift(1,SEMAShift);
   SetIndexShift(2,SSEMAShift);
//---- first positions skipped when drawing
   SetIndexDrawBegin(0,EMAShift+EMAPeriod);
   SetIndexDrawBegin(1,SEMAShift+SEMAPeriod);
   SetIndexDrawBegin(2,SSEMAShift+SSEMAPeriod);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer1);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexBuffer(2,ExtBuffer3);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,EMPTY,2);
   SetIndexStyle(1,DRAW_LINE,EMPTY,2);
   SetIndexStyle(2,DRAW_LINE,EMPTY,3);
//---- index labels
  
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| 3 X EMA                                          |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   for(int i=0; i<limit; i++)
     {
      //---- ma_shift set to 0 because SetIndexShift called above
      ExtBuffer1[i]=iMA(NULL,0,EMAPeriod,0,MODE_EMA,PRICE_CLOSE,i); 
      ExtBuffer2[i]=iMA(NULL,0,SEMAPeriod,0,MODE_EMA,PRICE_OPEN,i); 
      ExtBuffer3[i]=iMA(NULL,0,SSEMAPeriod,0,MODE_SMA,PRICE_CLOSE,i); 
     }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

